
local MakePlayerCharacter = require "prefabs/player_common"


local assets = {

        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
        Asset("SOUND", "sound/wx78.fsb"),
        Asset( "ANIM", "anim/beard.zip" ),

		-- Don't forget to include your character's custom assets!
        Asset( "ANIM", "anim/chica.zip" ),
}
local prefabs = {
"sparks"
}

local start_inv = {}


	local function dorainsparks(inst, dt)

	local mitigates_rain = false
	for k,v in pairs (inst.components.inventory.equipslots) do
		if v.components.dapperness then
			if v.components.dapperness.mitigates_rain then
				mitigates_rain = true
			end
		end		
	end
	
    if GetSeasonManager() and GetSeasonManager():IsRaining() and not mitigates_rain then
    	inst.spark_time = inst.spark_time - dt

    	if inst.spark_time <= 0 then
    		
    		--GetClock():DoLightningLighting()
    		inst.spark_time = 3+math.random()*2
    		inst.components.health:DoDelta(-.5, false, "rain")
			local pos = Vector3(inst.Transform:GetWorldPosition())
			pos.y = pos.y + 1 + math.random()*1.5
			local spark = SpawnPrefab("sparks")
			spark.Transform:SetPosition(pos:Get())
			
    	end
    end

end

local function updatestats(inst)

   if GetClock():IsDay() then


		inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * .8)
		inst.components.locomotor.runspeed = (TUNING.WILSON_WALK_SPEED * .9)

		inst.components.combat.damagemultiplier = 3

	
    end


end



local fn = function(inst)
	
	-- choose which sounds this character will play
	inst.soundsname = "wx78"
    inst.entity:AddMiniMapEntity()
	-- a minimap icon must be specified
	-- a minimap icon must be specified
    inst.MiniMapEntity:SetIcon( "chicamap.tex" )
	
	-- todo: Add an example special power here.
	
	inst.spark_time = 3
	
	inst.components.health:SetMaxHealth(150)
	inst.components.hunger:SetMax(100)
	inst.components.sanity:SetMax(80)
	
	
	inst.components.sanity.night_drain_mult = -14
	
	
	inst.components.eater.ignoresspoilage = true
	
	
	local Combat = Class(function(self, inst)
	--attack range is how far away the enemy is where the player will try to take a jab at it
	inst.components.combat.attackrange = 3
	--hitrange how far the player can actually hit
	inst.components.combat.hitrange = 3
	--attack_period is how long it takes to attack
	inst.components.combat.min_attack_period = 4
	
	inst:DoPeriodicTask(1/10, function() dorainsparks(inst, 1/10) end)
	
    end)
	
	
end




STRINGS.CHARACTERS.chica= require "speech_chica"

return MakePlayerCharacter("chica", prefabs, assets, fn, start_inv)
